/* parsed class NVCD97 */

#include "nvtypes.h"
#include "clcd97.h"

#include <assert.h>
#include <stdio.h>
#include "util/u_math.h"

struct nv_nvcd97_SET_ST_A {
    uint32_t offset_upper;
};

static inline void
__NVCD97_SET_ST_A(uint32_t *val_out, struct nv_nvcd97_SET_ST_A st)
{
    uint32_t val = 0;
    
    assert(st.offset_upper < (1ULL << 8));
    val |= st.offset_upper << 0;
    *val_out = val;
}

#define V_NVCD97_SET_ST_A(val, args...) { \
    struct nv_nvcd97_SET_ST_A __data = { .offset_upper = (args) }; \
    __NVCD97_SET_ST_A(&val, __data); \
}

#define VA_NVCD97_SET_ST_A V_NVCD97_SET_ST_A

#define P_NVCD97_SET_ST_A(push, args...) do { \
    uint32_t nvk_p_ret; \
    V_NVCD97_SET_ST_A(nvk_p_ret, args); \
    nv_push_val(push, NVCD97_SET_ST_A, nvk_p_ret); \
} while(0)

struct nv_nvcd97_SET_ST_B {
    uint32_t offset_lower;
};

static inline void
__NVCD97_SET_ST_B(uint32_t *val_out, struct nv_nvcd97_SET_ST_B st)
{
    uint32_t val = 0;
    
    val |= st.offset_lower;
    *val_out = val;
}

#define V_NVCD97_SET_ST_B(val, args...) { \
    struct nv_nvcd97_SET_ST_B __data = { .offset_lower = (args) }; \
    __NVCD97_SET_ST_B(&val, __data); \
}

#define VA_NVCD97_SET_ST_B V_NVCD97_SET_ST_B

#define P_NVCD97_SET_ST_B(push, args...) do { \
    uint32_t nvk_p_ret; \
    V_NVCD97_SET_ST_B(nvk_p_ret, args); \
    nv_push_val(push, NVCD97_SET_ST_B, nvk_p_ret); \
} while(0)

struct nv_nvcd97_SET_ST_BLOCK_SIZE {
    uint32_t width;
    uint32_t height;
    uint32_t depth;
};

static inline void
__NVCD97_SET_ST_BLOCK_SIZE(uint32_t *val_out, struct nv_nvcd97_SET_ST_BLOCK_SIZE st)
{
    uint32_t val = 0;
    
    assert(st.width < (1ULL << 4));
    val |= st.width << 0;
    
    assert(st.height < (1ULL << 4));
    val |= st.height << 4;
    
    assert(st.depth < (1ULL << 4));
    val |= st.depth << 8;
    *val_out = val;
}

#define V_NVCD97_SET_ST_BLOCK_SIZE(val, args...) { \
    UNUSED uint32_t WIDTH_ONE_GOB = NVCD97_SET_ST_BLOCK_SIZE_WIDTH_ONE_GOB; \
    UNUSED uint32_t HEIGHT_ONE_GOB = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_ONE_GOB; \
    UNUSED uint32_t HEIGHT_TWO_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_TWO_GOBS; \
    UNUSED uint32_t HEIGHT_FOUR_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_FOUR_GOBS; \
    UNUSED uint32_t HEIGHT_EIGHT_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_EIGHT_GOBS; \
    UNUSED uint32_t HEIGHT_SIXTEEN_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_SIXTEEN_GOBS; \
    UNUSED uint32_t HEIGHT_THIRTYTWO_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_THIRTYTWO_GOBS; \
    UNUSED uint32_t DEPTH_ONE_GOB = NVCD97_SET_ST_BLOCK_SIZE_DEPTH_ONE_GOB; \
    struct nv_nvcd97_SET_ST_BLOCK_SIZE __data = args; \
    __NVCD97_SET_ST_BLOCK_SIZE(&val, __data); \
}

#define VA_NVCD97_SET_ST_BLOCK_SIZE V_NVCD97_SET_ST_BLOCK_SIZE

#define P_NVCD97_SET_ST_BLOCK_SIZE(push, args...) do { \
    UNUSED uint32_t WIDTH_ONE_GOB = NVCD97_SET_ST_BLOCK_SIZE_WIDTH_ONE_GOB; \
    UNUSED uint32_t HEIGHT_ONE_GOB = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_ONE_GOB; \
    UNUSED uint32_t HEIGHT_TWO_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_TWO_GOBS; \
    UNUSED uint32_t HEIGHT_FOUR_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_FOUR_GOBS; \
    UNUSED uint32_t HEIGHT_EIGHT_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_EIGHT_GOBS; \
    UNUSED uint32_t HEIGHT_SIXTEEN_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_SIXTEEN_GOBS; \
    UNUSED uint32_t HEIGHT_THIRTYTWO_GOBS = NVCD97_SET_ST_BLOCK_SIZE_HEIGHT_THIRTYTWO_GOBS; \
    UNUSED uint32_t DEPTH_ONE_GOB = NVCD97_SET_ST_BLOCK_SIZE_DEPTH_ONE_GOB; \
    uint32_t nvk_p_ret; \
    V_NVCD97_SET_ST_BLOCK_SIZE(nvk_p_ret, args); \
    nv_push_val(push, NVCD97_SET_ST_BLOCK_SIZE, nvk_p_ret); \
} while(0)

struct nv_nvcd97_SET_ST_ARRAY_PITCH {
    uint32_t v;
};

static inline void
__NVCD97_SET_ST_ARRAY_PITCH(uint32_t *val_out, struct nv_nvcd97_SET_ST_ARRAY_PITCH st)
{
    uint32_t val = 0;
    
    val |= st.v;
    *val_out = val;
}

#define V_NVCD97_SET_ST_ARRAY_PITCH(val, args...) { \
    struct nv_nvcd97_SET_ST_ARRAY_PITCH __data = { .v = (args) }; \
    __NVCD97_SET_ST_ARRAY_PITCH(&val, __data); \
}

#define VA_NVCD97_SET_ST_ARRAY_PITCH V_NVCD97_SET_ST_ARRAY_PITCH

#define P_NVCD97_SET_ST_ARRAY_PITCH(push, args...) do { \
    uint32_t nvk_p_ret; \
    V_NVCD97_SET_ST_ARRAY_PITCH(nvk_p_ret, args); \
    nv_push_val(push, NVCD97_SET_ST_ARRAY_PITCH, nvk_p_ret); \
} while(0)

struct nv_nvcd97_SET_ZT_FORMAT {
    uint32_t v;
    uint32_t stencil_is_separate;
};

static inline void
__NVCD97_SET_ZT_FORMAT(uint32_t *val_out, struct nv_nvcd97_SET_ZT_FORMAT st)
{
    uint32_t val = 0;
    
    assert(st.v < (1ULL << 5));
    val |= st.v << 0;
    
    assert(st.stencil_is_separate < (1ULL << 1));
    val |= st.stencil_is_separate << 8;
    *val_out = val;
}

#define V_NVCD97_SET_ZT_FORMAT(val, args...) { \
    UNUSED uint32_t V_Z16 = NVCD97_SET_ZT_FORMAT_V_Z16; \
    UNUSED uint32_t V_Z24S8 = NVCD97_SET_ZT_FORMAT_V_Z24S8; \
    UNUSED uint32_t V_X8Z24 = NVCD97_SET_ZT_FORMAT_V_X8Z24; \
    UNUSED uint32_t V_S8Z24 = NVCD97_SET_ZT_FORMAT_V_S8Z24; \
    UNUSED uint32_t V_S8 = NVCD97_SET_ZT_FORMAT_V_S8; \
    UNUSED uint32_t V_ZF32 = NVCD97_SET_ZT_FORMAT_V_ZF32; \
    UNUSED uint32_t V_ZF32_X24S8 = NVCD97_SET_ZT_FORMAT_V_ZF32_X24S8; \
    UNUSED uint32_t STENCIL_IS_SEPARATE_FALSE = NVCD97_SET_ZT_FORMAT_STENCIL_IS_SEPARATE_FALSE; \
    UNUSED uint32_t STENCIL_IS_SEPARATE_TRUE = NVCD97_SET_ZT_FORMAT_STENCIL_IS_SEPARATE_TRUE; \
    struct nv_nvcd97_SET_ZT_FORMAT __data = args; \
    __NVCD97_SET_ZT_FORMAT(&val, __data); \
}

#define VA_NVCD97_SET_ZT_FORMAT V_NVCD97_SET_ZT_FORMAT

#define P_NVCD97_SET_ZT_FORMAT(push, args...) do { \
    UNUSED uint32_t V_Z16 = NVCD97_SET_ZT_FORMAT_V_Z16; \
    UNUSED uint32_t V_Z24S8 = NVCD97_SET_ZT_FORMAT_V_Z24S8; \
    UNUSED uint32_t V_X8Z24 = NVCD97_SET_ZT_FORMAT_V_X8Z24; \
    UNUSED uint32_t V_S8Z24 = NVCD97_SET_ZT_FORMAT_V_S8Z24; \
    UNUSED uint32_t V_S8 = NVCD97_SET_ZT_FORMAT_V_S8; \
    UNUSED uint32_t V_ZF32 = NVCD97_SET_ZT_FORMAT_V_ZF32; \
    UNUSED uint32_t V_ZF32_X24S8 = NVCD97_SET_ZT_FORMAT_V_ZF32_X24S8; \
    UNUSED uint32_t STENCIL_IS_SEPARATE_FALSE = NVCD97_SET_ZT_FORMAT_STENCIL_IS_SEPARATE_FALSE; \
    UNUSED uint32_t STENCIL_IS_SEPARATE_TRUE = NVCD97_SET_ZT_FORMAT_STENCIL_IS_SEPARATE_TRUE; \
    uint32_t nvk_p_ret; \
    V_NVCD97_SET_ZT_FORMAT(nvk_p_ret, args); \
    nv_push_val(push, NVCD97_SET_ZT_FORMAT, nvk_p_ret); \
} while(0)

struct nv_nvcd97_SET_ST_SIZE_A {
    uint32_t width;
};

static inline void
__NVCD97_SET_ST_SIZE_A(uint32_t *val_out, struct nv_nvcd97_SET_ST_SIZE_A st)
{
    uint32_t val = 0;
    
    assert(st.width < (1ULL << 28));
    val |= st.width << 0;
    *val_out = val;
}

#define V_NVCD97_SET_ST_SIZE_A(val, args...) { \
    struct nv_nvcd97_SET_ST_SIZE_A __data = { .width = (args) }; \
    __NVCD97_SET_ST_SIZE_A(&val, __data); \
}

#define VA_NVCD97_SET_ST_SIZE_A V_NVCD97_SET_ST_SIZE_A

#define P_NVCD97_SET_ST_SIZE_A(push, args...) do { \
    uint32_t nvk_p_ret; \
    V_NVCD97_SET_ST_SIZE_A(nvk_p_ret, args); \
    nv_push_val(push, NVCD97_SET_ST_SIZE_A, nvk_p_ret); \
} while(0)

struct nv_nvcd97_SET_ST_SIZE_B {
    uint32_t height;
};

static inline void
__NVCD97_SET_ST_SIZE_B(uint32_t *val_out, struct nv_nvcd97_SET_ST_SIZE_B st)
{
    uint32_t val = 0;
    
    assert(st.height < (1ULL << 18));
    val |= st.height << 0;
    *val_out = val;
}

#define V_NVCD97_SET_ST_SIZE_B(val, args...) { \
    struct nv_nvcd97_SET_ST_SIZE_B __data = { .height = (args) }; \
    __NVCD97_SET_ST_SIZE_B(&val, __data); \
}

#define VA_NVCD97_SET_ST_SIZE_B V_NVCD97_SET_ST_SIZE_B

#define P_NVCD97_SET_ST_SIZE_B(push, args...) do { \
    uint32_t nvk_p_ret; \
    V_NVCD97_SET_ST_SIZE_B(nvk_p_ret, args); \
    nv_push_val(push, NVCD97_SET_ST_SIZE_B, nvk_p_ret); \
} while(0)


const char *P_PARSE_NVCD97_MTHD(uint16_t idx);
void P_DUMP_NVCD97_MTHD_DATA(FILE *fp, uint16_t idx, uint32_t data,
                              const char *prefix);
